_ENV = _G


local raider_loadouts = {}

function Empire.get_design_prefs(empire,design_args)
  local loadout_hint, ship_drawer, config_name in design_args

  if empire.monster_faction=='ancient_sd'
    return PartOrdering.armored_autodesign
  end

  local loadout_pref = loadout_hints_to_prefs[loadout_hint?] or 'generic_autodesign'
  --print(design_args.design_name, loadout_hint, loadout)

  --cloaking designs
  if (empire:known 'Distortion Field') and not (drawers[ship_drawer])?.fixed_defense
    raider_pref = loadout_pref .. '_raider'

    if PartOrdering[raider_pref]
      loadout_pref = raider_pref
    end
  end

  return PartOrdering[loadout_pref]
end

