_ENV = _G

--!! Design.new
function Design.new(args)
  local _TRACE_TABLE=args

  local empire,config_name in args!
  local _ENV = new_instance(Design,DesignProperty)
  local design=_ENV
  design.empire=empire
  design.config_name=config_name
  design.design_hint=args.design_hint
  design.loadout_hint=args.loadout_hint
  design.carrying_design=args.carrying_design

  if args.planet_info
    design.planet_info = copy(args.planet_info)
  end


  if args.planet_drawer
    planet_drawer in args !
    ship_drawer=planet_drawer
    --print(..config_name)
  else
    ship_drawer in args!
    --console(..config_name)
  end

  --design.config_table = config_table

  design_name = args.design_name or
    new_design_name( true, empire.designs,  config_name)

  if(not drawer_t) trace_error("invalid drawer: " .. tostring(ship_drawer)) end

  cost_discount,fixed_defense in drawer_t

  if(not drawer_t)
    trace_error(tostring(drawers).."invalid ship_drawer: \""..ship_drawer.."\"")
  end


  active_mods={}
  filled_mounts={}



  -- make sure the mount info is setup properly
  for i = 1,num_mounts()
    init_mount_info(i)
  end


  -- generate base_hull_specs


  for k,v in pairs(extras?) do
    design[k]=v
  end


  return design
end